#!/usr/bin/perl

###################################################################
#  GTChat 0.95 Alpha Plugin                                       #
#  Written for release 20020911                                   #
#  Author: Michael Becker                                         #
#  michael@vonbecker.de                                           #
#  This plugin is a simple Quiz Botty                             #
###################################################################

package GTChat::Plugins::Quiz_botty;
use strict;

return bless({
        action_handlers => {
                'botty_quiz' => \&botty_quiz,
                'quiz_write' => \&quiz_write,
                'quiz_write_end' => \&quiz_write_end,
                'quiz_start' => \&quiz_start,
                'quiz_delete' => \&quiz_delete,
                                },

        command_handlers => {
                'quiz' => \&quiz,
                'quiz_win' => \&quiz_win,
                },

});
sub checkText
{

        my($self,$main,$text) = @_;

     if ($$text =~ s/^\/quiz_win(\s+|$)// )
        {
                $$text = ' '.$$text;
        }

 if ($main->{settings}{quiz})
    {
       $main->open (*FILE, "Plugins/Quiz/quiz.txt");
         my@lines = <FILE>;
         my$lines = shift (@lines);
         my$stamp=pop(@lines);
         $main->close(*FILE);
         my@antwort = split(/&/, $lines);
         my@stamp = split(/&/, $stamp);
         my$antwort=$antwort[1];
         my@winner;
         my$status=$stamp[1];my $oldtime=$stamp[0];
           chomp($oldtime);
            my$newtime=$main->{runtime}{now}-$oldtime;

           if ($antwort[0] ne "start_quiz")
           {
             if ($status == 1 and $newtime > 5){&quiz_win}

             if ($$text =~ m/$antwort/i)
               {
                $$text = '/quiz_win '.$$text;
                }


               elsif ($newtime > $main->{settings}{quiz_time})
                       {   my$output=$main->createOutput({
                        template => 'admin',
                        name => 'Quizzy',
                        nick => 'Quissy',
                        color => $main->{settings}{quiz_color},
                         text => "Die richtige Antwort wre gewesen: $antwort",
                                  });

                      if ($main->{settings}{quiz_room_on})
               {
               $output->restrictToRoom($main->{settings}{quiz_room});
                $main->sendOutputStrings($output);

                }

         else {$main->sendOutputStrings($output);}


                          $lines = shift(@lines);
                          my@frage = split(/&/, $lines);
                          my$frage=$frage[0];
                          my$antwort=$frage[1];
                          unshift (@lines, $lines);

                           if ($frage =~ m/quiz_end/i ){
                               $main->open (*FILE, "Settings.dat");
                                  my@set = <FILE>;
                                  $main->close(*FILE);

                                     for(@set){s/quiz => 1,/quiz => 0,/}

                                 $main->open (*FILE, ">Settings.dat");
                                  print FILE @set ;
                                   $main->close(*FILE);

                               &quiz_end }

                          else{

                         $main->open(*FILE, ">Plugins/Quiz/quiz.txt") || return undef;
                               print FILE @lines;
                               print FILE "$main->{runtime}{now}\n";
                            $main->close(*FILE);





                my$output=$main->createOutput({
            template => 'admin',
            name => 'Quizzy',
            nick => 'Quissy',
            color => $main->{settings}{quiz_color},
            text => $frage,
                                 });



                if ($main->{settings}{quiz_room_on})
               {
               $output->restrictToRoom($main->{settings}{quiz_room});
                $main->sendOutputStrings($output);

                }

         else {$main->sendOutputStrings($output);}




                        } }




 }

  }





 sub botty_quiz{
      my($self,$main,$test) = @_;

my$buffer = $ENV{'QUERY_STRING'};
my%FORM;
my($name,$value,$pair);
my@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $name =~ tr/+/ /;
  $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
                        }


  my$zeile = "$FORM{frage}"."&"."$FORM{antwort}"."&"."\n";

   $main->open(*FILE, '>>Plugins/Quiz/quiz_add.txt')or die "$!";
   print FILE $zeile;
   $main->close(*FILE);
   $main->printTemplate('admin/admin_quiz_botty');


        }






sub quiz_end{

 my($self,$main,$test) = @_;

   $main->open(*FILE, "Plugins/winner.txt") || return undef;
   my@winner = <FILE>;
   $main->close(*FILE);

               my@champion = split(/&/, $winner[0]);
               my$champion=$champion[0];
               my$championcount=$champion[1];
               my$champ_points=$main->{settings}{quiz_champ_points};
               chomp $championcount;



                      if ($main->{settings}{quiz_points_on})
                          {
                           my $candidates = $main->getPossibleOnlineUsers($champion);
                           my $user = $candidates->[0];
                            $main->loadUser($user->{name},$user);
                                $user->{points} = $user->{points} + $champ_points;
                            $main->saveUser($user);
                           }

                 my$output=$main->createOutput({
            template => 'admin',
            name => 'Quizzy',
            nick => 'Quissy',
            color => $main->{settings}{quiz_color},
            text => "$champion hat gewonnen!! Herzlichen Glckwunsch zu $championcount richtigen Antworten!",
                                 });

                     my$output1=$main->createOutput({
            template => 'admin',
            name => 'Quizzy',
            nick => 'Quissy',
            color => $main->{settings}{quiz_color},
            text => "$champion werden werden $champ_points Chatpoints gutgeschrieben! ",
                                 });

                # $output1->restrictToCurrentUser();

                if ($main->{settings}{quiz_room_on})
               {
               $output->restrictToRoom($main->{settings}{quiz_room});
               }

          $main->sendOutputStrings($output);
          $main->sendOutputStrings($output1);

            unlink("Plugins/Quiz/quiz.txt");



 }
sub quiz{


  my($self,$main) = @_;


 if ($main->{settings}{quiz})
     {


      $main->open(*FILE, "Plugins/winner.txt") || return undef;
       my@winner = <FILE>;
       $main->close(*FILE);


      my@first = split(/&/, $winner[0]);
      my$firstcount=$first[1];my$firstname=$first[0];
      my $max = @winner;my($winnercount,$winnername);my@lastline;my$mycount=0;
                 for(my $i = 0; $i < $max; $i++)
      {

           my$winner=shift(@winner);
           @lastline = split(/&/, $winner);
           $winnercount=$lastline[1];$winnername=$lastline[0];

           if ($winnername eq $main->{current_user}{nick})

                      {
                      $mycount=$winnercount;
                      }

         }
         chomp $firstcount;chomp $mycount;

         my$output=$main->createOutput({
            template => 'admin',
            name => 'Quizzy',
            nick => 'Quissy',
            color => $main->{settings}{quiz_color},
            text => "$firstname fhrt mit $firstcount richtigen Antworten.Du hast bisher $mycount mal richtig geantwortet!",
                                 });
           $output->restrictToCurrentUser();
           $main->sendOutputStrings($output);
   }
   else{
    my$output=$main->createOutput({
            template => 'admin',
            name => 'Quizzy',
            nick => 'Quissy',
            color => '$main->{settings}{quiz_color}',
            text => "schn, dass du dich fr das Quiz interessierst $main->{current_user}{nick}, aber im Moment ist kein Quiz aktiv.",
                                 });
           $output->restrictToCurrentUser();
           $main->sendOutputStrings($output);
   }


}
sub quiz_win{

 $main->open (*FILE, "Plugins/Quiz/quiz.txt");
         my@lines = <FILE>;
         my$lines = shift (@lines);
         $main->close(*FILE);
         my$stamp=pop(@lines);
         my@antwort = split(/&/, $lines);
         my@stamp = split(/&/, $stamp);
        my$antwort=$antwort[1];
         my@winner;
          my$champ = $main->{current_user}{nick};
          my$oldtime=$stamp[0];  my$reftime=$main->{runtime}{now}-$oldtime;
          my$status=$stamp[1];my$win_points=$main->{settings}{quiz_win_points};

          if ($status != 1)
   {

                my$output = $main->createOutput({
                template => 'admin',
                name => 'Quizzy',
                nick => 'Quissy',
                color => $main->{settings}{quiz_color},
                text => "$champ hat richtig geantwortet! Die Lsung ist: $antwort.",
             });



                my$output1 = $main->createOutput({
                template => 'admin',
                name => 'Quizzy',
                nick => 'Quissy',
                color => $main->{settings}{quiz_color},
                text => "Du bekommst $win_points Chatpoint gutgeschrieben!",
             });

                $output1->restrictToCurrentUser();

              my $candidates = $main->getPossibleOnlineUsers($champ);


              if ($main->{settings}{quiz_points_on})

                          {
                           my $user = $candidates->[0];
                            $main->loadUser($user->{name},$user);
                                $user->{points} = $user->{points} + $win_points;
                            $main->saveUser($user);
                           }


            if ($main->{settings}{quiz_room_on})
               {
               $output->restrictToRoom($main->{settings}{quiz_room});
                }

         $main->sendOutputStrings($output);
         $main->sendOutputStrings($output1);





   $main->open(*FILE, "Plugins/winner.txt") || return undef;
   @winner = <FILE>;
   $main->close(*FILE);


      my@first = split(/&/, $winner[0]);
      my$firstcount=$first[1];
      my $max = @winner;my$winnercount;my@lastline;my$winnername;my$exist;my@newwinner;
           for(my $i = 0; $i < $max; $i++)
      {

           my$winner=shift(@winner);
           @lastline = split(/&/, $winner);
           $winnercount=$lastline[1];$winnername=$lastline[0];


           if ($winnername eq $main->{current_user}{nick})

                      {$winnercount++;$exist=1;

                      if ($winnercount > $firstcount)
                             {unshift (@newwinner,$winnername."&".$winnercount."\n")}
                      else   {push (@newwinner,$winnername."&".$winnercount."\n")}
                      }
           else   {push (@newwinner,$winner)}
         }





            if ($exist){
            $main->open(*FILE, ">Plugins/winner.txt") || return undef;
            print FILE @newwinner;
            $main->close(*FILE);}


            else{
             $main->open(*FILE, ">>Plugins/winner.txt") || return undef;
             print FILE $main->{current_user}{nick}."&1\n";
             $main->close(*FILE);}


               push (@lines,$main->{runtime}{now}."&"."1"."&\n");


       $main->open(*FILE, ">Plugins/Quiz/quiz.txt") || return undef;
                 print FILE @lines;

                 $main->close(*FILE);
  }








#pop(@lines);

 my$frage = $antwort[0];








          if ($frage =~ m/quiz_end/i )
               {

                 $main->open (*FILE, "Settings.dat");
                 my@set = <FILE>;
                 $main->close(*FILE);

                 for(@set){s/quiz => 1,/quiz => 0,/}

                 $main->open (*FILE, ">Settings.dat");
                  print FILE @set ;
                 $main->close(*FILE);


                 $frage="Das Quiz ist beendet";

               }

      if ($status == 1 and $reftime > 5)
{
          my$output=$main->createOutput({
            template => 'admin',
            name => 'Quizzy',
            nick => 'Quissy',
            color => $main->{settings}{quiz_color},
            text => $frage,
                                 });



              if ($main->{settings}{quiz_room_on})
               {
               $output->restrictToRoom($main->{settings}{quiz_room});
                $main->sendOutputStrings($output);

                }

             else {$main->sendOutputStrings($output);}




        # $main->open(*FILE, ">>Plugins/Quiz/quiz.txt") || return undef;
                  push (@lines,$main->{runtime}{now}."&"."0"."&\n");
                   unshift (@lines,$lines);
                  $main->open(*FILE, ">Plugins/Quiz/quiz.txt") || return undef;
                  print FILE @lines;
                 #print FILE "$main->{runtime}{now}"."&"."1"."&\n";
                 $main->close(*FILE);
                 #print FILE "$main->{runtime}{now}"."&"."0"."&\n";
                # $main->close(*FILE);
  }

       if($frage eq "Das Quiz ist beendet"){&quiz_end};




     }  }
   sub quiz_write{

      my($self,$main) = @_;

print "Content-type: text/html\n\n";
print "<html>";
print "<head>";
print "</head>";
print "<body text='#000000' bgcolor='#E0E0E0' link='#FF0000' alink='#FF0000' vlink='#FF0000'>";
print "<h2>Bereits vorhandene Quizes:</h2><br>";


    foreach my$file (<Plugins/Quiz/*>)
                  {
          my@filename = split(/\//, $file);
          my$filename = pop (@filename);
          chomp $filename;

    if ($filename ne "quiz.txt" and $filename ne "quiz_add.txt"){ print "<font color='#0000FF'>$filename </font>";}

                   }
         print "<br><br><br>";
        $main->printTemplate('admin/quiz_write');

     }
 sub quiz_write_end
 {
      my($self,$main) = @_;



my$buffer = $ENV{'QUERY_STRING'};
my%FORM;
my($name,$value,$pair);
my@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $name =~ tr/+/ /;
  $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
                        }


  my$quizname = $FORM{quizname};




    $main->open (*FILE, "Plugins/Quiz/quiz_add.txt")or die "$!"  ;
                 my@set = <FILE>;
   $main->close(*FILE);




    $main->open (*FILE, ">>Plugins/Quiz/$quizname")or die "$!";
                  print FILE @set ;
   $main->close(*FILE);
             chmod(0666, "Plugins/Quiz/$quizname") || die "Cannot chmod $quizname: $!";

    unlink("Plugins/Quiz/quiz_add.txt");






     $main->printTemplate('admin/menu_back');
 }
 sub quiz_start{

     my($self,$main) = @_;


              $main->printTemplate('admin/menu_back');

        my$buffer = $ENV{'QUERY_STRING'};
my%FORM;
my($name,$value,$pair);
my@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $name =~ tr/+/ /;
  $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
                        }


  my$quizname = $FORM{quizname};


          $main->open (*FILE, "Plugins/Quiz/$quizname");
                   my@lines = <FILE>;
                     $main->close(*FILE);
                     my$anzahl=@lines;

                     unlink("Plugins/Quiz/quiz.txt");

                  $main->open (*FILE, ">Plugins/Quiz/quiz.txt");
                     print FILE @lines;
                 $main->close(*FILE);
                   chmod(0666, "Plugins/Quiz/quiz.txt") || die "Cannot chmod quiz.txt: $!";

                  my$lines = shift (@lines);

                  my@frage = split(/&/, $lines);
                  my$frage=$frage[0];



     if ($frage ne "")
     {  $main->open (*FILE, ">Plugins/winner.txt");
       print FILE ;
       $main->close(*FILE);

       $main->open (*FILE, ">>Plugins/Quiz/quiz.txt");
       print FILE "quiz_end&\n";
       print FILE "$main->{runtime}{now}\n";
       $main->close(*FILE);
      }


     else {$frage="Es sind keine fragen vorhanden!";


          $main->open (*FILE, "Settings.dat");
           my@set = <FILE>;
          $main->close(*FILE);

          for(@set){s/quiz => 1,/quiz => 0,/}

          $main->open (*FILE, ">Settings.dat");
           print FILE @set ;
          $main->close(*FILE);

         }
          my$output = $main->createOutput({
       template => 'admin',
       name => 'Quizzy',
       nick => 'Quissy',
       color => $main->{settings}{quiz_color},
       text => "Hallo Leute..wir machen jetzt ein Quiz mit $anzahl Fragen!!",

                                     });


        if ($main->{settings}{quiz_room_on})
               {
               $output->restrictToRoom($main->{settings}{quiz_room});
                $main->sendOutputStrings($output);

                }

         else {$main->sendOutputStrings($output);}




      my$output = $main->createOutput({
            template => 'admin',
            name => 'Quizzy',
            nick => 'Quissy',
            color => $main->{settings}{quiz_color},
            text => $frage,
             });

           if ($main->{settings}{quiz_room_on})
               {
               $output->restrictToRoom($main->{settings}{quiz_room});
                $main->sendOutputStrings($output);

                }

         else {$main->sendOutputStrings($output);}

              $main->printTemplate('admin/menu_back');

   }
sub quiz_delete{


      my($self,$main) = @_;


 my$buffer = $ENV{'QUERY_STRING'};
my%FORM;
my($name,$value,$pair);
my@pairs = split(/&/, $buffer);
foreach $pair (@pairs) {
  ($name, $value) = split(/=/, $pair);
  $name =~ tr/+/ /;
  $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
                        }


  my$quizname = $FORM{quizname};

    unlink("Plugins/Quiz/$quizname");



     $main->printTemplate('admin/menu_back');
 }